"""mouse.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the game's meeces.
"""

import globals as g

import pygame
from pygame.locals import *

pointerStrings = {
"pointer":(["               ..               ",
"              ..+.              ",
"              .++.              ",
"              ..+.              ",
"              .++.              ",
"              ..+.              ",
"              .++.              ",
"              ..+.              ",
"              .++.              ",
"              ..+.              ",
"              .++.              ",
"               ..               ",
"                                ",
"               ..               ",
" ..........   .++.   .......... ",
".++++++++++. .+.++. .+.+.+.+.+..",
"..+.+.+.+.+. ..+.+. .++++++++++.",
" ..........   ..+.   .......... ",
"               ..               ",
"                                ",
"               ..               ",
"              .++.              ",
"              .+..              ",
"              .++.              ",
"              .+..              ",
"              .++.              ",
"              .+..              ",
"              .++.              ",
"              .+..              ",
"              .++.              ",
"              .+..              ",
"               ..               "],(15,15)) , 

"select" : ([" ........    ......    ........ ",
"..+.+.+.+.  .++++++.  .+.+.+.+..",
".++++++++.  .++++++.  .++++++++.",
"..+......    ......    ......+..",
".++.                        .++.",
"..+.                        .+..",
".++.                        .++.",
"..+.                        .+..",
".++.                        .++.",
" ..                          .. ",
"                                ",
"                                ",
" ..                          .. ",
".++.                        .++.",
".++.                        .++.",
".++.                        .++.",
".++.                        .++.",
".++.                        .++.",
".++.                        .++.",
" ..                          .. ",
"                                ",
"                                ",
" ..                          .. ",
".++.                        .++.",
"..+.                        .+..",
".++.                        .++.",
"..+.                        .+..",
".++.                        .++.",
"..+......    ......    ......+..",
".++++++++.  .++++++.  .++++++++.",
"..+.+.+.+.  .++++++.  .+.+.+.+..",
" ........    ......    ........ "], (15,15)),

"hand":(["                                ",
"    +++                         ",
"  ++...++++                     ",
" +.........++                   ",
" +...........++                 ",
" +.............+                ",
" +..............+               ",
" +...............+              ",
" ++..............+              ",
"  ++.............+              ",
"  +++.............+             ",
"   +.+............+             ",
"   +..+...........+++           ",
"    +..+..........+..+          ",
"    +.............+...+         ",
"    ++...........+.....+        ",
"     ++.........+.......+       ",
"     ++++.....++.........+      ",
"      ++++++++...........+      ",
"        +++++.+.+.........+     ",
"          ++++.+..........+     ",
"             ++.+.+.......+     ",
"             +++.+.......+      ",
"              +++.+.+...++      ",
"              ++++.+.+.+++      ",
"               ++++.+.+++       ",
"               +++++++++        ",
"                +++++++         ",
"                 +++++          ",
"                                ",
"                                ",
"                                "],(3,3)) }

class Mouse:
    def __init__(self):
        self.cursors = {}
        for s in pointerStrings.keys():
            a, b = pygame.cursors.compile(pointerStrings[s][0], black=".", white="+") # for some reason these are mixed up
            self.cursors[s] = (  (len(pointerStrings[s][0][0]), len(pointerStrings[s][0])), 
                pointerStrings[s][1], a, b)
        self.currentCursor = ""
        self.changeCursor("pointer")
        return

    def changeCursor(self, key):
        if not self.currentCursor == key:
            a, b, c, d = self.cursors[key]
            pygame.mouse.set_cursor(a, b, c, d)
            self.currentCursor = key
        return
