"""s_actfloater.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming floater anim.
"""

import globals as g
from excepts import *

attrs = {"isDeathAction": False, "isOnGround": False, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}

oscillate = [1,2,3,3,2,1,0,0] # curse those byte-pinching sods at dma design, making animations non linear :/ 

def update(lemming):
    try:
        if lemming.brollyJustOpened:
            if lemming.floaterFrame == 0:
                pass
            elif lemming.floaterFrame == 1:
                lemming.posY -= 1
            elif lemming.floaterFrame == 2 or lemming.floaterFrame == 3:
                lemming.posY += 1
            else:
                lemming.brollyJustOpened = False
                lemming.floaterFrame = 0
            lemming.rect.midbottom = (lemming.posX, lemming.posY+1)
            if lemming.checkPos((lemming.posX, lemming.posY+1), "ground"):
                lemming.setSkill("s_walker")

        if not lemming.brollyJustOpened: #intentional so it can jump from the first if statement
            if not(lemming.checkPos((lemming.posX, lemming.posY+1), "ground")):
                if not (lemming.checkPos((lemming.posX, lemming.posY+2), "ground")):
                    if (lemming.checkPos((lemming.posX, lemming.posY+3), "ground")):
                        lemming.posY += 2
                        lemming.setSkill("s_walker")
                    else: 
                        lemming.posY += 2
                        if not lemming.currentFrame == oscillate[lemming.floaterFrame]:
                            lemming.currentFrame = oscillate[lemming.floaterFrame]
                            lemming.image = g.skillCache.frames(lemming.currentSkill)[lemming.direction][0][lemming.currentFrame]                        
                        lemming.rect.midbottom = (lemming.posX, lemming.posY+1)
                else:
                    lemming.posY += 1
                    lemming.setSkill("s_walker")
            else: # rare case scenario
                lemming.setSkill("s_walker")

        lemming.floaterFrame += 1
        lemming.floaterFrame %= len(oscillate)
        if (lemming.checkPos((lemming.posX, lemming.posY-1), "exit" )):
            lemming.setSkill("s_leaver") 
    except OutOfThePlayfield:
        lemming.kill()    
    return

def set(lemming):
    lemming.currentSkill = "s_actfloater"
    lemming.currentFrame = 1
    lemming.floaterFrame = 0
    lemming.altitude = 0
    lemming.rect.left = frames[lemming.direction][1].left
    lemming.rect.right = frames[lemming.direction][1].right
    lemming.rect.width = frames[lemming.direction][1].width
    lemming.rect.height = frames[lemming.direction][1].height
    lemming.frameCount = len(frames[lemming.direction][0])
    lemming.brollyJustOpened = True    
    lemming._incAnimFrame()
    return
